/*
Copyright (c) 2007-2010 Nokia Corporation and/or its subsidiary(-ies). All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
 list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright notice,
 this list of conditions and the following disclaimer in the documentation
 and/or other materials provided with the distribution.
* Neither the name of Nokia Corporation nor the names of its contributors
 may be used to endorse or promote products derived from this software
 without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Description: 
*/



#ifndef __PNGCONVERT_H__
#define __PNGCONVERT_H__

#include <icl/imageplugin.h>

#include "PNGCodec.h"

//
// PNG decoder class
//
class CPngDecoder : public CImageDecoderPlugin
	{
public:
	// Construction
 	static CPngDecoder* NewL();
	~CPngDecoder();

private:
	// from CImageDecoderPlugin
	
	// Gets the image type and sub-type for a given frame of the image that
	// has just been decoded.
	virtual void ImageType(TInt aFrameNumber, TUid& aImageType, TUid& aImageSubType) const;	
	// Gets text descriptions of image properties
	CFrameInfoStrings* FrameInfoStringsL(RFs& aFs, TInt aFrameNumber);
	// Scans the image header.
	void ScanDataL();

private:
	CPngDecoder();
	void ReadFormatL();
	};

//
// PNG encoder class
//
class CPngEncoder : public CImageEncoderPlugin
	{
public:
	// Construction
	static CPngEncoder* NewL();
	 ~CPngEncoder();

private:
	// from CImageEncoderPlugin

	// Sets up the codec to encode the frame
	void PrepareEncoderL(const CFrameImageData* aFrameImageData);
	// Update header (not used)
	void UpdateHeaderL() {};

private:
	CPngEncoder();
	};

#endif // __PNGCONVERT_H__
